using System;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace MainModClass
{
    public class ExtremeColorChanger : MonoBehaviour
    {
        public void Start()
        {
            StartCoroutine(ChangeColor());
        }

        public IEnumerator ChangeColor()
        {
            float RandomTime = UnityEngine.Random.Range(0.35f, 0.65f);
            yield return new WaitForSeconds(RandomTime);

            float RandomColor1 = UnityEngine.Random.Range(0.00f, 1.00f);
            float RandomColor2 = UnityEngine.Random.Range(0.00f, 1.00f);
            float RandomColor3 = UnityEngine.Random.Range(0.00f, 1.00f);

            transform.gameObject.GetComponent<SpriteRenderer>().color = new Color(RandomColor1, RandomColor2, RandomColor3, 1f);

            StartCoroutine(ChangeColor());
        }
    }
}