using System;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace MainModClass
{
    public class ExtremeMassHandler : MonoBehaviour
    {

        public void Start()
        {
            StartCoroutine(UpdateMass());
        }

        public IEnumerator UpdateMass()
        {
            float RandomMass = UnityEngine.Random.Range(-150.00f, 150.00f);
            float RandomTime = UnityEngine.Random.Range(0.35f, 0.65f);
            yield return new WaitForSeconds(RandomTime);

            transform.gameObject.GetComponent<PhysicalBehaviour>().rigidbody.mass = RandomMass;
            transform.gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = RandomMass / 2;

            StartCoroutine(UpdateMass());
        }
    }
}