using System;
using System.Collections.Generic;
using System.Collections;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace MainModClass
{
    public class ExtremeTemperatureHandler : MonoBehaviour
    {
        public bool Cold = false;
        public bool Hot = false;

        public void Start()
        {
            if (Hot == true)
            {
                StartCoroutine(UpdateHeat());
            }
            if (Cold == true)
            {
                StartCoroutine(UpdateCold());
            }
        }

        public IEnumerator UpdateHeat()
        {
            yield return (object)new WaitForSeconds(0.025f);

            transform.gameObject.GetComponent<SpriteRenderer>().color = new Color(1f, 0.5f, 0f);
            transform.gameObject.GetComponent<PhysicalBehaviour>().Temperature = 1000000000f;
            transform.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = 100f;
            transform.gameObject.GetComponent<PhysicalBehaviour>().Wetness = 0f;

            if (Hot == true)
            {
                StartCoroutine(UpdateHeat());
            }
        }

        public IEnumerator UpdateCold()
        {
            yield return (object)new WaitForSeconds(0.025f);

            transform.gameObject.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f);
            transform.gameObject.GetComponent<PhysicalBehaviour>().Temperature = -100000000f;
            transform.gameObject.GetComponent<PhysicalBehaviour>().burnIntensity = 0f;
            transform.gameObject.GetComponent<PhysicalBehaviour>().Wetness = 100f;

            if (Cold == true)
            {
                StartCoroutine(UpdateCold());
            }
        }
    }
}