using System;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using MainModClass;

namespace MainModClass
{
    public class HuskTentacleHandler : MonoBehaviour
    {
        public float Random1;
        public float Random2;
        public float RadnomLenght1;
        public float RadnomLenght2;
        public float RadnomLenght3;
        public bool MiddleTentacle;
        public bool DownTentacle;
        public bool UpTentacle;
        private bool HasBeenSet;
        public void Update()
        {
            if (HasBeenSet == false)
            {
                RadnomLenght1 = UnityEngine.Random.Range(-0.0625f, 0.0625f);
                RadnomLenght2 = UnityEngine.Random.Range(-0.0625f, 0.0625f);
                RadnomLenght3 = UnityEngine.Random.Range(-0.0625f, 0.0625f);
                Random1 = UnityEngine.Random.Range(-20, -30);
                Random2 = UnityEngine.Random.Range(20, 30);
                if (UpTentacle == true)
                {
                    transform.position = this.transform.parent.transform.position;
                    transform.position += new Vector3(RadnomLenght1, 0.0625f, 0);
                }
                if (MiddleTentacle == true)
                {
                    transform.position = this.transform.parent.transform.position;
                    transform.position += new Vector3(RadnomLenght2, 0f, 0);
                }
                if (DownTentacle == true)
                {
                    transform.position = this.transform.parent.transform.position;
                    transform.position -= new Vector3(RadnomLenght3, 0.0625f, 0);
                }
                HasBeenSet = true;
            }
            if (HasBeenSet == true)
            {
                Vector3 euler = transform.eulerAngles;
                if (euler.z > 180) euler.z = euler.z - 360;
                euler.z = Mathf.Clamp(euler.z, Random1, Random2);
                transform.eulerAngles = euler;
            }
        }
    }
}