using System;
using System.Collections.Generic;
using System.Linq;
using System.Reflection;
using UnityEngine;
namespace MainModClass
{
    public class MainModClass
    {
        public static AudioClip GrenadePin = ModAPI.LoadSound("Sounds/GrenadePin.wav");

        public static AudioClip HuskDeadSound1 = ModAPI.LoadSound("Sounds/Husk1roar.wav");

        public static AudioClip HuskIdleSound1 = ModAPI.LoadSound("Sounds/Husk6Idle.wav");
        public static AudioClip HuskIdleSound2 = ModAPI.LoadSound("Sounds/Husk7Idle.wav");

        public static AudioClip HuskTransformSound1 = ModAPI.LoadSound("Sounds/Husk3TransformationScream.wav");
        public static AudioClip HuskTransformSound2 = ModAPI.LoadSound("Sounds/Husk4TransformationScream.wav");
        public static AudioClip HuskTransformSound3 = ModAPI.LoadSound("Sounds/Husk5TransformationScream.wav");

        public static Sprite RadiationBleedingEyes1 = ModAPI.LoadSprite("Textures/RadiationBleedingEyes1.png");

        public static Sprite ExtraArm1 = ModAPI.LoadSprite("Textures/HuskInfectionExtraArm1.png");
        public static Sprite ExtraArm2 = ModAPI.LoadSprite("Textures/HuskInfectionExtraArm2.png");
        public static Sprite ExtraArm3 = ModAPI.LoadSprite("Textures/HuskInfectionExtraArm3.png");

        public static Sprite Claw1 = ModAPI.LoadSprite("Textures/HuskInfectionClaw1.png");
        public static Sprite Claw2 = ModAPI.LoadSprite("Textures/HuskInfectionClaw2.png");
        public static Sprite Claw3 = ModAPI.LoadSprite("Textures/HuskInfectionClaw3.png");

        public static Sprite Tentacle1 = ModAPI.LoadSprite("Textures/HuskInfectionFaceTentacle1.png");
        public static Sprite Tentacle2 = ModAPI.LoadSprite("Textures/HuskInfectionFaceTentacle2.png");
        public static Sprite Tentacle3 = ModAPI.LoadSprite("Textures/HuskInfectionFaceTentacle3.png");

        public static Sprite HuskInfectionFaceAnomaly1 = ModAPI.LoadSprite("Textures/HuskInfectionFaceAnomaly1.png");
        public static Sprite HuskInfectionFaceAnomaly2 = ModAPI.LoadSprite("Textures/HuskInfectionFaceAnomaly2.png");
        public static Sprite HuskInfectionFaceAnomaly3 = ModAPI.LoadSprite("Textures/HuskInfectionFaceAnomaly3.png");
        public static Sprite HuskInfectionFaceAnomaly4 = ModAPI.LoadSprite("Textures/HuskInfectionFaceAnomaly4.png");
        public static Sprite HuskInfectionFaceAnomaly5 = ModAPI.LoadSprite("Textures/HuskInfectionFaceAnomaly5.png");

        public static Sprite HuskInfectionFaceAnomalyEyes1 = ModAPI.LoadSprite("Textures/HuskInfectionFaceAnomalyEyes1.png");
        public static Sprite HuskInfectionFaceAnomalyEyes2 = ModAPI.LoadSprite("Textures/HuskInfectionFaceAnomalyEyes2.png");
        public static Sprite HuskInfectionFaceAnomalyEyes3 = ModAPI.LoadSprite("Textures/HuskInfectionFaceAnomalyEyes3.png");
        public static Sprite HuskInfectionFaceAnomalyEyes4 = ModAPI.LoadSprite("Textures/HuskInfectionFaceAnomalyEyes4.png");
        public static Sprite HuskInfectionFaceAnomalyEyes5 = ModAPI.LoadSprite("Textures/HuskInfectionFaceAnomalyEyes5.png");

        public static Sprite CordycepsHuskInfectionFaceAnomaly1 = ModAPI.LoadSprite("Textures/CordycepsHuskInfectionFaceAnomaly1.png");
        public static Sprite CordycepsHuskInfectionFaceAnomaly2 = ModAPI.LoadSprite("Textures/CordycepsHuskInfectionFaceAnomaly2.png");
        public static Sprite CordycepsHuskInfectionFaceAnomaly3 = ModAPI.LoadSprite("Textures/CordycepsHuskInfectionFaceAnomaly3.png");
        public static Sprite CordycepsHuskInfectionFaceAnomaly4 = ModAPI.LoadSprite("Textures/CordycepsHuskInfectionFaceAnomaly4.png");
        public static Sprite CordycepsHuskInfectionFaceAnomaly5 = ModAPI.LoadSprite("Textures/CordycepsHuskInfectionFaceAnomaly5.png");
        public static Sprite CordycepsHuskInfectionFaceAnomaly6 = ModAPI.LoadSprite("Textures/CordycepsHuskInfectionFaceAnomaly6.png");
        
        public static Sprite CordycepsClaw1 = ModAPI.LoadSprite("Textures/CordycepsHuskInfectionClaw1.png");
        public static Sprite CordycepsClaw2 = ModAPI.LoadSprite("Textures/CordycepsHuskInfectionClaw2.png");
        public static Sprite CordycepsClaw3 = ModAPI.LoadSprite("Textures/CordycepsHuskInfectionClaw3.png");

        public static Sprite TEARSBleedingEyes1 = ModAPI.LoadSprite("Textures/TEARSBleedingEyes1.png");
        public static Sprite TEARSBleedingEyes2 = ModAPI.LoadSprite("Textures/TEARSBleedingEyes2.png");
        public static Sprite TEARSBleedingEyes3 = ModAPI.LoadSprite("Textures/TEARSBleedingEyes3.png");

        public static Sprite HeadcrabAttachedSprite = ModAPI.LoadSprite("Textures/HeadcrabStandingStillAttached.png");
        public static Sprite HeadcrabAttachedSpriteBack = ModAPI.LoadSprite("Textures/HeadcrabStandingStillBackAttached.png");

        public static Sprite FastHeadcrabAttachedSprite = ModAPI.LoadSprite("Textures/FastHeadcrabStandingStillAttached.png");
        public static Sprite FastHeadcrabAttachedSpriteBack = ModAPI.LoadSprite("Textures/FastHeadcrabStandingStillBackAttached.png");

        public static Sprite PoisonHeadcrabAttachedSprite = ModAPI.LoadSprite("Textures/PoisonHeadcrabStandingStillAttached.png");
        public static Sprite PoisonHeadcrabAttachedSpriteBack = ModAPI.LoadSprite("Textures/PoisonHeadcrabStandingStillBackAttached.png");

        public static Sprite SkulkcrabAttachedSprite = ModAPI.LoadSprite("Textures/SculkcrabStandingStillAttached.png");
        public static Sprite SkulkcrabAttachedSpriteBack = ModAPI.LoadSprite("Textures/SculkcrabStandingStillBackAttached.png");

        public static Sprite HeadcrabClaw1 = ModAPI.LoadSprite("Textures/HeadcrabZombieClaw1.png");
        public static Sprite HeadcrabClaw2 = ModAPI.LoadSprite("Textures/HeadcrabZombieClaw2.png");
        public static Sprite FastHeadcrabClaw = ModAPI.LoadSprite("Textures/FastHeadcrabZombieClaw1.png");
        public static Sprite SkulkcrabClaw = ModAPI.LoadSprite("Textures/SkulkcrabZombieClaw1.png");
        public static Sprite PoisonHeadcrabClaw = ModAPI.LoadSprite("Textures/PoisonHeadcrabZombieClaw1.png");

        public static void Main()
        {
            CategoryBuilder.Create("Science Hazard Minus", "<color=green>Some Stuff that's quite special (and also very likely dangerous) in terms of Physics, Biology and Chemistry in some form atleast", ModAPI.LoadSprite("Textures/PlaguesView.png"));

            Liquid.Register(HeadcrabBlood.ID, new HeadcrabBlood());
            Liquid.Register(SkulkcrabBlood.ID, new SkulkcrabBlood());
            Liquid.Register(VelonacepsCalyxBlood.ID, new VelonacepsCalyxBlood());
            Liquid.Register(CordycepsSpores.ID, new CordycepsSpores());
            Liquid.Register(TEARSVirus.ID, new TEARSVirus());
            Liquid.Register(ZombieCure.ID, new ZombieCure());
            Liquid.Register(Calyxanide.ID, new Calyxanide());
            Liquid.Register(UraniumIsotopeVirus.ID, new UraniumIsotopeVirus());
            Liquid.Register(AntiRadiation.ID, new AntiRadiation());
            //Headcrabs Normal
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Pumpkin"),
                NameOverride = "Headcrab",
                NameToOrderByOverride = "0",
                DescriptionOverride = "A Headcrab is a parasitic entity which actively searches for Human Heads to Control over and to feed one....It's still not really known how this creature controls it's Host,however recent reports and claims of various Scientists suggest that the Headcrabs establish a neuronal connection with the Brain and the Brainstem of their Host via a hidden Spike (or multiple ones).If the Headcrab is able to take over an Host it will then apply various bodily modification and so on....",
                CategoryOverride = ModAPI.FindCategory("Science Hazard Minus"),
                ThumbnailOverride = ModAPI.LoadSprite("Textures/HeadcrabView.png"),
                AfterSpawn = (System.Action<GameObject>)(Instance =>
                {
                    UnityEngine.Object.Destroy(Instance.GetComponent<JackOLaternBehaviour>().LightSprite);
                    UnityEngine.Object.Destroy(Instance.GetComponent<JackOLaternBehaviour>());
                    UnityEngine.Object.Destroy(Instance.GetComponent<RandomSpriteBehaviour>());
                    Instance.GetComponent<DestroyableBehaviour>().ShotBreakChance = 0.2f;
                    Instance.GetComponent<DestroyableBehaviour>().MinimumImpactForce = 12.5f;
                    float AttackForce = 0.15f;
                    Rigidbody2D RB = Instance.GetComponent<PhysicalBehaviour>().rigidbody;
                    Instance.AddComponent<UseEventTrigger>().Action = (System.Action)(() =>
                    {
                        var TargetHead = Resources.FindObjectsOfTypeAll<GameObject>().Where(obj => obj.name == "Head");
                        if (TargetHead != null)
                        {
                            foreach(GameObject gam in TargetHead)
                            {
                                if(gam.transform.GetComponentInChildren<NormalHeadcrabInfectionBehaviour>() == null)
                                { 
                                }
                            }
                            Transform bestTarget = null;
                            float closestDistanceSqr = 45;
                            Vector3 currentPosition = Instance.transform.position;
                            foreach (GameObject potentialTarget in TargetHead)
                            {
                                Vector3 directionToTarget = potentialTarget.transform.position - currentPosition;
                                float dSqrToTarget = directionToTarget.sqrMagnitude;
                                if (dSqrToTarget < closestDistanceSqr)
                                {
                                    bool HasAlreadyHeadcrab = false;
                                    foreach (Transform child in potentialTarget.transform)
                                    {
                                        if (child.GetComponent<NormalHeadcrabInfectionBehaviour>() != null)
                                        {
                                            HasAlreadyHeadcrab = true;
                                        }
                                    }
                                    if (HasAlreadyHeadcrab == false)
                                    {
                                        closestDistanceSqr = dSqrToTarget;
                                        bestTarget = potentialTarget.transform;
                                        RB.AddForce((bestTarget.GetComponent<Rigidbody2D>().position - RB.position) * AttackForce, ForceMode2D.Impulse);
                                    }
                                }
                            }
                        }
                    });
                    Instance.AddComponent<NormalHeadcrabInfectionBehaviour>();
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/HeadcrabStandingStill.png");
                    Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                    ArmorBehaviour Armor = Instance.AddComponent<ArmorBehaviour>();
                    Armor.threepieces = false;
                    Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
                    Armor.stabResistance = 0.0f;
                    Armor.armorPiece = "Head";
                    Armor.armorTier = 0;
                    Armor.IsHeadcrab = true;
                    Armor.IsNormalHeadcrab = true;
                    Instance.FixColliders();
                    GameObject HeadcrabLegsBehind = new GameObject("BackgroundHeadcrabLimbs");
                    HeadcrabLegsBehind.transform.SetParent(Instance.transform);
                    HeadcrabLegsBehind.transform.localPosition = new Vector3(0.0f, 0.0f);
                    HeadcrabLegsBehind.transform.localScale = new Vector3(1f, 1f);
                    SpriteRenderer spriteRenderer = HeadcrabLegsBehind.AddComponent<SpriteRenderer>();
                    spriteRenderer.sprite = ModAPI.LoadSprite("Textures/HeadcrabStandingStillBack.png");
                    spriteRenderer.sortingLayerName = "Background";
                    Armor.HeadcrabBackLegsSprite = spriteRenderer;
                    Instance.GetComponent<PhysicalProperties>().Brittleness = 1f;
                    /*
                    Instance.AddComponent<PolygonCollider2D>();
                    Instance.gameObject.GetComponent<PolygonCollider2D>().pathCount = 1;
                    Instance.gameObject.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[25]
                    {
          new Vector2(-0.0891037f, -0.06000423f),
          new Vector2(-0.07036591f, -0.08045006f),
          new Vector2(-0.06958771f,-0.1202555f),
          new Vector2(-0.04010773f,-0.120225f),
          new Vector2(-0.03618622f,-0.1033411f),
          new Vector2(-0.04997253f,-0.09022427f),
          new Vector2(-0.05958557f,-0.06003666f),
          new Vector2(-0.05952454f,-0.0403738f),
          new Vector2(-0.02981567f,-0.02996063f),
          new Vector2(0.01979065f,-0.05052853f),

          new Vector2(0.03997803f,-0.08055115f),
          new Vector2(0.04032898f,-0.1100206f),
          new Vector2(0.03029633f,-0.120286f),
          new Vector2(0.04976654f,-0.1199007f),
          new Vector2(0.06630707f,-0.09289932f),
          new Vector2(0.06024933f,-0.06053734f),

          new Vector2(0.07978821f,-0.06060886f),
          new Vector2(0.09979248f,-0.03057289f),
          new Vector2(0.0998764f,0.009405136f),
          new Vector2(0.08925629f,0.02950001f),
          new Vector2(0.06931305f,0.05017853f),
          new Vector2(0.02993347f,0.07000275f),
          new Vector2(-0.04994965f,0.06993599f),
          new Vector2(-0.07898712f,0.0287075f),
          new Vector2(-0.08996582f,-0.01104259f),
                    });
                    */
                })
            });
            //Skulkcrab
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Pumpkin"),
                NameOverride = "Skulkcrab",
                NameToOrderByOverride = "-1",
                DescriptionOverride = "It's a Skulkcrab!!?....",
                CategoryOverride = ModAPI.FindCategory("Science Hazard Minus"),
                ThumbnailOverride = ModAPI.LoadSprite("Textures/SkulkcrabView.png"),
                AfterSpawn = (System.Action<GameObject>)(Instance =>
                {
                    UnityEngine.Object.Destroy(Instance.GetComponent<JackOLaternBehaviour>().LightSprite);
                    UnityEngine.Object.Destroy(Instance.GetComponent<JackOLaternBehaviour>());
                    UnityEngine.Object.Destroy(Instance.GetComponent<RandomSpriteBehaviour>());
                    Instance.GetComponent<DestroyableBehaviour>().ShotBreakChance = 0.1f;
                    Instance.GetComponent<DestroyableBehaviour>().MinimumImpactForce = 12.5f;
                    float AttackForce = 0.15f;
                    Rigidbody2D RB = Instance.GetComponent<PhysicalBehaviour>().rigidbody;
                    Instance.AddComponent<UseEventTrigger>().Action = (System.Action)(() =>
                    {
                        var TargetHead = Resources.FindObjectsOfTypeAll<GameObject>().Where(obj => obj.name == "Head");
                        if (TargetHead != null)
                        {
                            foreach (GameObject gam in TargetHead)
                            {
                                if (gam.transform.GetComponentInChildren<NormalHeadcrabInfectionBehaviour>() == null)
                                {
                                }
                            }
                            Transform bestTarget = null;
                            float closestDistanceSqr = 45;
                            Vector3 currentPosition = Instance.transform.position;
                            foreach (GameObject potentialTarget in TargetHead)
                            {
                                Vector3 directionToTarget = potentialTarget.transform.position - currentPosition;
                                float dSqrToTarget = directionToTarget.sqrMagnitude;
                                if (dSqrToTarget < closestDistanceSqr)
                                {
                                    bool HasAlreadyHeadcrab = false;
                                    foreach (Transform child in potentialTarget.transform)
                                    {
                                        if (child.GetComponent<NormalHeadcrabInfectionBehaviour>() != null)
                                        {
                                            HasAlreadyHeadcrab = true;
                                        }
                                    }
                                    if (HasAlreadyHeadcrab == false)
                                    {
                                        closestDistanceSqr = dSqrToTarget;
                                        bestTarget = potentialTarget.transform;
                                        RB.AddForce((bestTarget.GetComponent<Rigidbody2D>().position - RB.position) * AttackForce, ForceMode2D.Impulse);
                                    }
                                }
                            }
                        }
                    });
                    Instance.AddComponent<NormalHeadcrabInfectionBehaviour>();
                    Instance.GetComponent<NormalHeadcrabInfectionBehaviour>().IsSkulkcrab = true;
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/SculkcrabStandingStill.png");
                    Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                    ArmorBehaviour Armor = Instance.AddComponent<ArmorBehaviour>();
                    Armor.threepieces = false;
                    Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
                    Armor.stabResistance = 0.0f;
                    Armor.armorPiece = "Head";
                    Armor.armorTier = 0;
                    Armor.IsHeadcrab = true;
                    Armor.IsSkulkcrab = true;
                    Instance.FixColliders();
                    GameObject HeadcrabLegsBehind = new GameObject("BackgroundHeadcrabLimbs");
                    HeadcrabLegsBehind.transform.SetParent(Instance.transform);
                    HeadcrabLegsBehind.transform.localPosition = new Vector3(0.0f, 0.0f);
                    HeadcrabLegsBehind.transform.localScale = new Vector3(1f, 1f);
                    SpriteRenderer spriteRenderer = HeadcrabLegsBehind.AddComponent<SpriteRenderer>();
                    spriteRenderer.sprite = ModAPI.LoadSprite("Textures/SculkcrabStandingStillBack.png");
                    spriteRenderer.sortingLayerName = "Background";
                    Armor.HeadcrabBackLegsSprite = spriteRenderer;
                    Instance.GetComponent<PhysicalProperties>().Brittleness = 1f;
                    /*
                    Instance.AddComponent<PolygonCollider2D>();
                    Instance.gameObject.GetComponent<PolygonCollider2D>().pathCount = 1;
                    Instance.gameObject.GetComponent<PolygonCollider2D>().SetPath(1, new Vector2[25]
                    {
          new Vector2(-0.0891037f, -0.06000423f),
          new Vector2(-0.07036591f, -0.08045006f),
          new Vector2(-0.06958771f,-0.1202555f),
          new Vector2(-0.04010773f,-0.120225f),
          new Vector2(-0.03618622f,-0.1033411f),
          new Vector2(-0.04997253f,-0.09022427f),
          new Vector2(-0.05958557f,-0.06003666f),
          new Vector2(-0.05952454f,-0.0403738f),
          new Vector2(-0.02981567f,-0.02996063f),
          new Vector2(0.01979065f,-0.05052853f),

          new Vector2(0.03997803f,-0.08055115f),
          new Vector2(0.04032898f,-0.1100206f),
          new Vector2(0.03029633f,-0.120286f),
          new Vector2(0.04976654f,-0.1199007f),
          new Vector2(0.06630707f,-0.09289932f),
          new Vector2(0.06024933f,-0.06053734f),

          new Vector2(0.07978821f,-0.06060886f),
          new Vector2(0.09979248f,-0.03057289f),
          new Vector2(0.0998764f,0.009405136f),
          new Vector2(0.08925629f,0.02950001f),
          new Vector2(0.06931305f,0.05017853f),
          new Vector2(0.02993347f,0.07000275f),
          new Vector2(-0.04994965f,0.06993599f),
          new Vector2(-0.07898712f,0.0287075f),
          new Vector2(-0.08996582f,-0.01104259f),
                    });
                    */
                })
            });
            //Headcrabs Fast
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Pumpkin"),
                NameOverride = "Fast Headcrab",
                NameToOrderByOverride = "1",
                DescriptionOverride = "A Variant of the Headcrab, which evolved longer legs and slightly higher muscle mass compared to the average Headcrab, to better hunt down it's prey (Humans) and to take it over...However the Controlled Victim will undergo heavy and deadly bodily modifications by the Headcrab,such as internal Organs be missing and so on...",
                CategoryOverride = ModAPI.FindCategory("Science Hazard Minus"),
                ThumbnailOverride = ModAPI.LoadSprite("Textures/FastHeadcrabView.png"),
                AfterSpawn = (System.Action<GameObject>)(Instance =>
                {
                    UnityEngine.Object.Destroy(Instance.GetComponent<JackOLaternBehaviour>().LightSprite);
                    UnityEngine.Object.Destroy(Instance.GetComponent<JackOLaternBehaviour>());
                    UnityEngine.Object.Destroy(Instance.GetComponent<RandomSpriteBehaviour>());
                    Instance.GetComponent<DestroyableBehaviour>().ShotBreakChance = 0.225f;
                    Instance.GetComponent<DestroyableBehaviour>().MinimumImpactForce = 12.5f;
                    float AttackForce = 0.15f;
                    Rigidbody2D RB = Instance.GetComponent<PhysicalBehaviour>().rigidbody;
                    Instance.AddComponent<UseEventTrigger>().Action = (System.Action)(() =>
                    {
                        var TargetHead = Resources.FindObjectsOfTypeAll<GameObject>().Where(obj => obj.name == "Head");
                        if (TargetHead != null)
                        {
                            Transform bestTarget = null;
                            float closestDistanceSqr = 45;
                            Vector3 currentPosition = Instance.transform.position;
                            foreach (GameObject potentialTarget in TargetHead)
                            {
                                Vector3 directionToTarget = potentialTarget.transform.position - currentPosition;
                                float dSqrToTarget = directionToTarget.sqrMagnitude;
                                if (dSqrToTarget < closestDistanceSqr)
                                {
                                    bool HasAlreadyHeadcrab = false;
                                    foreach (Transform child in potentialTarget.transform)
                                    {
                                        if (child.GetComponent<NormalHeadcrabInfectionBehaviour>() != null )
                                        {
                                            HasAlreadyHeadcrab = true;
                                        }
                                    }
                                    if (HasAlreadyHeadcrab == false)
                                    {
                                        closestDistanceSqr = dSqrToTarget;
                                        bestTarget = potentialTarget.transform;
                                        RB.AddForce((bestTarget.GetComponent<Rigidbody2D>().position - RB.position) * AttackForce, ForceMode2D.Impulse);
                                    }
                                }
                            }
                        }
                    });
                    Instance.AddComponent<NormalHeadcrabInfectionBehaviour>();
                    Instance.GetComponent<NormalHeadcrabInfectionBehaviour>().IsFastHeadcrab = true;
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/FastHeadcrabStandingStill.png");
                    Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                    ArmorBehaviour Armor = Instance.AddComponent<ArmorBehaviour>();
                    Armor.threepieces = false;
                    Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
                    Armor.stabResistance = 0.0f;
                    Armor.armorPiece = "Head";
                    Armor.armorTier = 0;
                    Armor.IsHeadcrab = true;
                    Armor.IsFastHeadcrab = true;
                    Instance.FixColliders();
                    GameObject HeadcrabLegsBehind = new GameObject("BackgroundHeadcrabLimbs");
                    HeadcrabLegsBehind.transform.SetParent(Instance.transform);
                    HeadcrabLegsBehind.transform.localPosition = new Vector3(0.0f, 0.0f);
                    HeadcrabLegsBehind.transform.localScale = new Vector3(1f, 1f);
                    SpriteRenderer spriteRenderer = HeadcrabLegsBehind.AddComponent<SpriteRenderer>();
                    spriteRenderer.sprite = ModAPI.LoadSprite("Textures/FastHeadcrabStandingStillBack.png");
                    spriteRenderer.sortingLayerName = "Background";
                    Armor.HeadcrabBackLegsSprite = spriteRenderer;
                    Instance.GetComponent<PhysicalProperties>().Brittleness = 1f;
                })
            });
            //Headcrabs Poison
            ModAPI.Register(new Modification()
            {
            OriginalItem = ModAPI.FindSpawnable("Pumpkin"),
                NameOverride = "Poison Headcrab",
                NameToOrderByOverride = "1",
                DescriptionOverride = "A Variant of the Headcrab, which evolved a neurotoxin for it's Prey and compared to the average Headcrab a darker skin which seem to be more durable...However it's Victim will undergo extreme bodily modifications by the Headcrab,such as the production of the toxin in the Host itself and so on...",
                CategoryOverride = ModAPI.FindCategory("Science Hazard Minus"),
                ThumbnailOverride = ModAPI.LoadSprite("Textures/PoisonHeadcrabView.png"),
                AfterSpawn = (System.Action<GameObject>)(Instance =>
                {
                    UnityEngine.Object.Destroy(Instance.GetComponent<JackOLaternBehaviour>().LightSprite);
                    UnityEngine.Object.Destroy(Instance.GetComponent<JackOLaternBehaviour>());
                    UnityEngine.Object.Destroy(Instance.GetComponent<RandomSpriteBehaviour>());
                    Instance.GetComponent<DestroyableBehaviour>().ShotBreakChance = 0.185f;
                    Instance.GetComponent<DestroyableBehaviour>().MinimumImpactForce = 12.5f;
                    float AttackForce = 0.15f;
                    Rigidbody2D RB = Instance.GetComponent<PhysicalBehaviour>().rigidbody;
                    Instance.AddComponent<UseEventTrigger>().Action = (System.Action)(() =>
                    {
                        var TargetHead = Resources.FindObjectsOfTypeAll<GameObject>().Where(obj => obj.name == "Head");
                        if (TargetHead != null)
                        {
                            Transform bestTarget = null;
                            float closestDistanceSqr = 45;
                            Vector3 currentPosition = Instance.transform.position;
                            foreach (GameObject potentialTarget in TargetHead)
                            {
                                Vector3 directionToTarget = potentialTarget.transform.position - currentPosition;
                                float dSqrToTarget = directionToTarget.sqrMagnitude;
                                if (dSqrToTarget < closestDistanceSqr)
                                {
                                    bool HasAlreadyHeadcrab = false;
                                    foreach (Transform child in potentialTarget.transform)
                                    {
                                        if (child.GetComponent<NormalHeadcrabInfectionBehaviour>() != null)
                                        {
                                            HasAlreadyHeadcrab = true;
                                        }
                                    }
                                    if (HasAlreadyHeadcrab == false)
                                    {
                                        closestDistanceSqr = dSqrToTarget;
                                        bestTarget = potentialTarget.transform;
                                        RB.AddForce((bestTarget.GetComponent<Rigidbody2D>().position - RB.position) * AttackForce, ForceMode2D.Impulse);
                                    }
                                }
                            }
                        }
                    });
                    Instance.AddComponent<NormalHeadcrabInfectionBehaviour>();
                    Instance.GetComponent<NormalHeadcrabInfectionBehaviour>().IsPoisonHeadcrab = true;
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/PoisonHeadcrabStandingStill.png");
                    Instance.GetComponent<SpriteRenderer>().sortingLayerName = "Default";
                    ArmorBehaviour Armor = Instance.AddComponent<ArmorBehaviour>();
                    Armor.threepieces = false;
                    Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Human");
                    Armor.stabResistance = 0.0f;
                    Armor.armorPiece = "Head";
                    Armor.armorTier = 0;
                    Armor.IsHeadcrab = true;
                    Armor.IsPoisonHeadcrab = true;
                    Instance.FixColliders();
                    GameObject HeadcrabLegsBehind = new GameObject("BackgroundHeadcrabLimbs");
                    HeadcrabLegsBehind.transform.SetParent(Instance.transform);
                    HeadcrabLegsBehind.transform.localPosition = new Vector3(0.0f, 0.0f);
                    HeadcrabLegsBehind.transform.localScale = new Vector3(1f, 1f);
                    SpriteRenderer spriteRenderer = HeadcrabLegsBehind.AddComponent<SpriteRenderer>();
                    spriteRenderer.sprite = ModAPI.LoadSprite("Textures/PoisonHeadcrabStandingStillBack.png");
                    spriteRenderer.sortingLayerName = "Background";
                    Armor.HeadcrabBackLegsSprite = spriteRenderer;
                    Instance.GetComponent<PhysicalProperties>().Brittleness = 1f;
                })
            });
            //  Void Architect
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "<color=red>Void Architect Weapon<color=white>",
                NameToOrderByOverride = "ZArchitect5",
                DescriptionOverride = "A Weapon which is able to create temporary Voids...Very powerfull and can be powered to enhance it's Strenght",
                CategoryOverride = ModAPI.FindCategory("Science Hazard Minus"),
                ThumbnailOverride = ModAPI.LoadSprite("Textures/VoidArchitectThumb.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/VoidArchitect.png");
                    Instance.FixColliders();
                    Instance.AddComponent<ArchitectWeaponHandler>();
                    Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                    Instance.GetComponent<PhysicalBehaviour>().InitialMass = 1f;
                    Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 1f;
                    Instance.GetComponent<PhysicalBehaviour>().Disintegratable = false;

                    Transform MineObject = Instance.transform;
                    GameObject gameObject1 = new GameObject("ShotingHandler");
                    gameObject1.transform.SetParent(MineObject);
                    gameObject1.transform.localPosition = new Vector3(0.8f, 0f);
                    gameObject1.transform.rotation = Quaternion.Euler(0.0f, 0.0f, 0.0f);
                    gameObject1.transform.localScale = new Vector3(1f, 1f);
                    gameObject1.AddComponent<ArchitectWeaponBehaviour>();
                    gameObject1.GetComponent<ArchitectWeaponBehaviour>().IsVoidArchitect = true;

                    GameObject gameObject2 = new GameObject("ArchitectLight");
                    gameObject2.transform.SetParent(MineObject);
                    gameObject2.transform.localPosition = new Vector3(0f, 0f);
                    gameObject2.transform.rotation = Quaternion.Euler(0.0f, 0.0f, 0.0f);
                    gameObject2.transform.localScale = new Vector3(1f, 1f);
                    SpriteRenderer spriteRenderer = gameObject2.AddComponent<SpriteRenderer>();
                    spriteRenderer.sprite = ModAPI.LoadSprite("Textures/VoidArchitectLight.png");
                    spriteRenderer.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                    spriteRenderer.sortingLayerName = "Top";
                }
            });
            // Explosion Architect
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "<color=orange>Explosion Architect Weapon<color=white>",
                NameToOrderByOverride = "ZArchitect1",
                DescriptionOverride = "A Weapon which is able to create a big Explosion...Powerfull and can be powered to enhance it's Strenght",
                CategoryOverride = ModAPI.FindCategory("Science Hazard Minus"),
                ThumbnailOverride = ModAPI.LoadSprite("Textures/ExplosionArchitectThumb.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/ExplosionArchitect.png");
                    Instance.FixColliders();
                    Instance.AddComponent<ArchitectWeaponHandler>();
                    Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                    Instance.GetComponent<PhysicalBehaviour>().InitialMass = 1f;
                    Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 1f;
                    Instance.GetComponent<PhysicalBehaviour>().Disintegratable = false;

                    Transform MineObject = Instance.transform;
                    GameObject gameObject = new GameObject("ShotingHandler");
                    gameObject.transform.SetParent(MineObject);
                    gameObject.transform.localPosition = new Vector3(0.8f, 0f);
                    gameObject.transform.rotation = Quaternion.Euler(0.0f, 0.0f, 0.0f);
                    gameObject.transform.localScale = new Vector3(1f, 1f);
                    gameObject.AddComponent<ArchitectWeaponBehaviour>();
                    gameObject.GetComponent<ArchitectWeaponBehaviour>().IsExplosionArchitect = true;

                    GameObject gameObject2 = new GameObject("ArchitectLight");
                    gameObject2.transform.SetParent(MineObject);
                    gameObject2.transform.localPosition = new Vector3(0f, 0f);
                    gameObject2.transform.rotation = Quaternion.Euler(0.0f, 0.0f, 0.0f);
                    gameObject2.transform.localScale = new Vector3(1f, 1f);
                    SpriteRenderer spriteRenderer = gameObject2.AddComponent<SpriteRenderer>();
                    spriteRenderer.sprite = ModAPI.LoadSprite("Textures/ExplosionArchitectLight.png");
                    spriteRenderer.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                    spriteRenderer.sortingLayerName = "Top";
                }
            });
            // Ultraviolet Architect
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "<color=purple>Ultraviolet Architect Weapon<color=white>",
                NameToOrderByOverride = "ZArchitect2",
                DescriptionOverride = "A Weapon which is able to send out high amounts of Ultraviolet and other unknown types of radiation bundled into a perfect Laser...Powerfull and can be powered to enhance it's Strenght",
                CategoryOverride = ModAPI.FindCategory("Science Hazard Minus"),
                ThumbnailOverride = ModAPI.LoadSprite("Textures/UltravioletArchitectThumb.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/UltravioletArchitect.png");
                    Instance.FixColliders();
                    Instance.AddComponent<ArchitectWeaponHandler>();
                    Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                    Instance.GetComponent<PhysicalBehaviour>().InitialMass = 1f;
                    Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 1f;
                    Instance.GetComponent<PhysicalBehaviour>().Disintegratable = false;

                    Transform MineObject = Instance.transform;
                    GameObject gameObject = new GameObject("ShotingHandler");
                    gameObject.transform.SetParent(MineObject);
                    gameObject.transform.localPosition = new Vector3(0.8f, 0f);
                    gameObject.transform.rotation = Quaternion.Euler(0.0f, 0.0f, 0.0f);
                    gameObject.transform.localScale = new Vector3(1f, 1f);
                    gameObject.AddComponent<ArchitectWeaponBehaviour>();
                    gameObject.GetComponent<ArchitectWeaponBehaviour>().IsUltravioletArchitect = true;

                    GameObject gameObject2 = new GameObject("ArchitectLight");
                    gameObject2.transform.SetParent(MineObject);
                    gameObject2.transform.localPosition = new Vector3(0f, 0f);
                    gameObject2.transform.rotation = Quaternion.Euler(0.0f, 0.0f, 0.0f);
                    gameObject2.transform.localScale = new Vector3(1f, 1f);
                    SpriteRenderer spriteRenderer = gameObject2.AddComponent<SpriteRenderer>();
                    spriteRenderer.sprite = ModAPI.LoadSprite("Textures/UltravioletArchitectLight.png");
                    spriteRenderer.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                    spriteRenderer.sortingLayerName = "Top";
                }
            });
            // EMP Architect
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "<color=blue>Electro Magnetic Pulse Architect Weapon<color=white>",
                NameToOrderByOverride = "ZArchitect3",
                DescriptionOverride = "A Weapon which is able to send out a Strong Electro Magnetic Pulse in Form of an beam...Mostly harmless,but very powerfull against most Machinery and can be powered to enhance it's Strenght",
                CategoryOverride = ModAPI.FindCategory("Science Hazard Minus"),
                ThumbnailOverride = ModAPI.LoadSprite("Textures/EMPArchitectThumb.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/EMPArchitect.png");
                    Instance.FixColliders();
                    Instance.AddComponent<ArchitectWeaponHandler>();
                    Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                    Instance.GetComponent<PhysicalBehaviour>().InitialMass = 1f;
                    Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 1f;
                    Instance.GetComponent<PhysicalBehaviour>().Disintegratable = false;

                    Transform MineObject = Instance.transform;
                    GameObject gameObject = new GameObject("ShotingHandler");
                    gameObject.transform.SetParent(MineObject);
                    gameObject.transform.localPosition = new Vector3(0.8f, 0f);
                    gameObject.transform.rotation = Quaternion.Euler(0.0f, 0.0f, 0.0f);
                    gameObject.transform.localScale = new Vector3(1f, 1f);
                    gameObject.AddComponent<ArchitectWeaponBehaviour>();
                    gameObject.GetComponent<ArchitectWeaponBehaviour>().IsEMPArchitect = true;

                    GameObject gameObject2 = new GameObject("ArchitectLight");
                    gameObject2.transform.SetParent(MineObject);
                    gameObject2.transform.localPosition = new Vector3(0f, 0f);
                    gameObject2.transform.rotation = Quaternion.Euler(0.0f, 0.0f, 0.0f);
                    gameObject2.transform.localScale = new Vector3(1f, 1f);
                    SpriteRenderer spriteRenderer = gameObject2.AddComponent<SpriteRenderer>();
                    spriteRenderer.sprite = ModAPI.LoadSprite("Textures/EMPArchitectLight.png");
                    spriteRenderer.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                    spriteRenderer.sortingLayerName = "Top";
                }
            });
            // Party Architect
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "<color=red>P<color=yellow>a<color=green>r<color=blue>t<color=purple>y <color=white>Architect Weapon<color=white>",
                NameToOrderByOverride = "ZArchitect3",
                DescriptionOverride = "A Weapon which is able to send out stuff related to Party or Fun...gets quite unpredictable when powered...Also do you wanna visit level 'Fun' and have a great Party there? =)",
                CategoryOverride = ModAPI.FindCategory("Science Hazard Minus"),
                ThumbnailOverride = ModAPI.LoadSprite("Textures/PartyArchitectThumb.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/PartyArchitect.png");
                    Instance.FixColliders();
                    Instance.AddComponent<ArchitectWeaponHandler>();
                    Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                    Instance.GetComponent<PhysicalBehaviour>().InitialMass = 1f;
                    Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 1f;
                    Instance.GetComponent<PhysicalBehaviour>().Disintegratable = false;

                    Transform MineObject = Instance.transform;
                    GameObject gameObject = new GameObject("ShotingHandler");
                    gameObject.transform.SetParent(MineObject);
                    gameObject.transform.localPosition = new Vector3(0.9f, 0f);
                    gameObject.transform.rotation = Quaternion.Euler(0.0f, 0.0f, 0.0f);
                    gameObject.transform.localScale = new Vector3(1f, 1f);
                    gameObject.AddComponent<ArchitectWeaponBehaviour>();
                    gameObject.GetComponent<ArchitectWeaponBehaviour>().IsPartyArchitect = true;

                    GameObject gameObject2 = new GameObject("ArchitectLight");
                    gameObject2.transform.SetParent(MineObject);
                    gameObject2.transform.localPosition = new Vector3(0f, 0f);
                    gameObject2.transform.rotation = Quaternion.Euler(0.0f, 0.0f, 0.0f);
                    gameObject2.transform.localScale = new Vector3(1f, 1f);
                    SpriteRenderer spriteRenderer = gameObject2.AddComponent<SpriteRenderer>();
                    spriteRenderer.sprite = ModAPI.LoadSprite("Textures/PartyArchitectLight.png");
                    spriteRenderer.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                    spriteRenderer.sortingLayerName = "Top";
                }
            });
            // Color Manipulator
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "<color=red>C<color=yellow>o<color=green>l<color=blue>o<color=purple>r <color=white>Manipulator Device<color=white>",
                NameToOrderByOverride = "ZArchitectMini3",
                DescriptionOverride = "A Device which is able to change the Color of an Object, by manipulating the lightrays which get absorbed and reflected by the Object ...gets quite unpredictable when powered... (you can also change the Color value in the Contextmenu of this Item)",
                CategoryOverride = ModAPI.FindCategory("Science Hazard Minus"),
                ThumbnailOverride = ModAPI.LoadSprite("Textures/ColorManipulatorThumb.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/ColorManipulator.png");
                    Instance.FixColliders();
                    Instance.AddComponent<ManipulatorDeviceHandler>();
                    Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                    Instance.GetComponent<PhysicalBehaviour>().InitialMass = 1f;
                    Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 1f;
                    Instance.GetComponent<PhysicalBehaviour>().Disintegratable = false;

                    Transform MineObject = Instance.transform;
                    GameObject gameObject = new GameObject("ShotingHandler");
                    gameObject.transform.SetParent(MineObject);
                    gameObject.transform.localPosition = new Vector3(0.1f, 0f);
                    gameObject.transform.rotation = Quaternion.Euler(0.0f, 0.0f, 0.0f);
                    gameObject.transform.localScale = new Vector3(1f, 1f);
                    gameObject.AddComponent<ManipulatorDeviceBehaviour>();
                    gameObject.GetComponent<ManipulatorDeviceBehaviour>().IsColourManipulatorDevice = true;

                    GameObject gameObject2 = new GameObject("ManipulatorLight");
                    gameObject2.transform.SetParent(MineObject);
                    gameObject2.transform.localPosition = new Vector3(0f, 0f);
                    gameObject2.transform.rotation = Quaternion.Euler(0.0f, 0.0f, 0.0f);
                    gameObject2.transform.localScale = new Vector3(1f, 1f);
                    SpriteRenderer spriteRenderer = gameObject2.AddComponent<SpriteRenderer>();
                    spriteRenderer.sprite = ModAPI.LoadSprite("Textures/ColorManipulatorLight.png");
                    spriteRenderer.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                    spriteRenderer.sortingLayerName = "Top";
                }
            });
            // Temperature Manipulator
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "<color=yellow>Temperature <color=white>Manipulator Device<color=white>",
                NameToOrderByOverride = "ZArchitectMini1",
                DescriptionOverride = "A Device which is able to change the Temperature of an Object...gets quite unpredictable when powered...(you can also change the Temperature value in the Contextmenu of this Item)",
                CategoryOverride = ModAPI.FindCategory("Science Hazard Minus"),
                ThumbnailOverride = ModAPI.LoadSprite("Textures/TemperatureManipulatorThumb.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/TemperatureManipulator.png");
                    Instance.FixColliders();
                    Instance.AddComponent<ManipulatorDeviceHandler>();
                    Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                    Instance.GetComponent<PhysicalBehaviour>().InitialMass = 1f;
                    Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 1f;
                    Instance.GetComponent<PhysicalBehaviour>().Disintegratable = false;

                    Transform MineObject = Instance.transform;
                    GameObject gameObject = new GameObject("ShotingHandler");
                    gameObject.transform.SetParent(MineObject);
                    gameObject.transform.localPosition = new Vector3(0.1f, 0f);
                    gameObject.transform.rotation = Quaternion.Euler(0.0f, 0.0f, 0.0f);
                    gameObject.transform.localScale = new Vector3(1f, 1f);
                    gameObject.AddComponent<ManipulatorDeviceBehaviour>();
                    gameObject.GetComponent<ManipulatorDeviceBehaviour>().IsTemperatureManipulatorDevice = true;

                    GameObject gameObject2 = new GameObject("ManipulatorLight");
                    gameObject2.transform.SetParent(MineObject);
                    gameObject2.transform.localPosition = new Vector3(0f, 0f);
                    gameObject2.transform.rotation = Quaternion.Euler(0.0f, 0.0f, 0.0f);
                    gameObject2.transform.localScale = new Vector3(1f, 1f);
                    SpriteRenderer spriteRenderer = gameObject2.AddComponent<SpriteRenderer>();
                    spriteRenderer.sprite = ModAPI.LoadSprite("Textures/TemperatureManipulatorLight.png");
                    spriteRenderer.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                    spriteRenderer.sortingLayerName = "Top";
                }
            });

            // Mass Manipulator
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Rod"),
                NameOverride = "<color=green>Mass <color=white>Manipulator Device<color=white>",
                NameToOrderByOverride = "ZArchitectMini2",
                DescriptionOverride = "A Device which is able to change the Mass, and therefore the gravity of an Object...gets quite unpredictable when powered...(you can also change the Mass value in the Contextmenu of this Item)",
                CategoryOverride = ModAPI.FindCategory("Science Hazard Minus"),
                ThumbnailOverride = ModAPI.LoadSprite("Textures/MassManipulatorThumb.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/MassManipulator.png");
                    Instance.FixColliders();
                    Instance.AddComponent<ManipulatorDeviceHandler>();
                    Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Metal");
                    Instance.GetComponent<PhysicalBehaviour>().InitialMass = 1f;
                    Instance.GetComponent<PhysicalBehaviour>().TrueInitialMass = 1f;
                    Instance.GetComponent<PhysicalBehaviour>().Disintegratable = false;

                    Transform MineObject = Instance.transform;
                    GameObject gameObject = new GameObject("ShotingHandler");
                    gameObject.transform.SetParent(MineObject);
                    gameObject.transform.localPosition = new Vector3(0.1f, 0f);
                    gameObject.transform.rotation = Quaternion.Euler(0.0f, 0.0f, 0.0f);
                    gameObject.transform.localScale = new Vector3(1f, 1f);
                    gameObject.AddComponent<ManipulatorDeviceBehaviour>();
                    gameObject.GetComponent<ManipulatorDeviceBehaviour>().IsGravityMassManipulatorDevice = true;

                    GameObject gameObject2 = new GameObject("ManipulatorLight");
                    gameObject2.transform.SetParent(MineObject);
                    gameObject2.transform.localPosition = new Vector3(0f, 0f);
                    gameObject2.transform.rotation = Quaternion.Euler(0.0f, 0.0f, 0.0f);
                    gameObject2.transform.localScale = new Vector3(1f, 1f);
                    SpriteRenderer spriteRenderer = gameObject2.AddComponent<SpriteRenderer>();
                    spriteRenderer.sprite = ModAPI.LoadSprite("Textures/MassManipulatorLight.png");
                    spriteRenderer.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                    spriteRenderer.sortingLayerName = "Top";
                }
            });

            //Syringes
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Life Syringe"),
                NameOverride = "Velonaceps Calyx Eggs Syringe",
                DescriptionOverride = "Velonaceps Calyx, also called Husk or Hull Parasite, is a parasitic lifeform found inside the subsurface, liquid water oceans of the Jupiter moon Europa.They basically infect their victim via consumtion or injection with their Eggs or they simply crawl into their victims mounth and then start to devour the victims Body,while it's alive until only the Hull is left...,which is then controlled by the Parasite itself",
                CategoryOverride = ModAPI.FindCategory("Science Hazard Minus"),
                NameToOrderByOverride = "A0",
                ThumbnailOverride = ModAPI.LoadSprite("Textures/HuskParasiteSyringeView.png"),
                AfterSpawn = (Instance) =>
                {
                    UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());

                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BioSyringe.png");
                    Instance.GetOrAddComponent<VelonacepsCalyxEggsSyringe>();

                    UnityEngine.Object.Destroy(Instance.GetComponent<Collider2D>());
                    Instance.AddComponent<PolygonCollider2D>();
                    Instance.GetComponent<PolygonCollider2D>().pathCount = 15;
                    Instance.GetComponent<PolygonCollider2D>().autoTiling = true;
                }
            });

            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Life Syringe"),
                NameOverride = "Cordyceps Fungus Spore Syringe",
                DescriptionOverride = "Cordyceps, A Fungus that came originaly from Brazil that commonly infects the nervous System of Ants and similar Insects by simply taking over the infected Brain and therefore taking over the host.The Host then behaves similar to a zombie basically and tries to spread the Fungus at any cost....However this Strain seems to have adapted to Humans and other Lifeforms other than just Ants...Let's hope we aren't The Last of us after a Pandemic with this thing...Let's hope not...",
                CategoryOverride = ModAPI.FindCategory("Science Hazard Minus"),
                NameToOrderByOverride = "A1",
                ThumbnailOverride = ModAPI.LoadSprite("Textures/CordycepsSyringeView.png"),
                AfterSpawn = (Instance) =>
                {
                    UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());

                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BioSyringe.png");
                    Instance.GetOrAddComponent<CordycepsFungusSporeSyringe>();

                    UnityEngine.Object.Destroy(Instance.GetComponent<Collider2D>());
                    Instance.AddComponent<PolygonCollider2D>();
                    Instance.GetComponent<PolygonCollider2D>().pathCount = 15;
                    Instance.GetComponent<PolygonCollider2D>().autoTiling = true;
                }
            });

            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Life Syringe"),
                NameOverride = "T.E.A.R.S Syringe",
                DescriptionOverride = "A Plague which turns the Victim insane with insane amounts of pain and lets the eyes bleed Blood, The Victims turn into Zombies or similar, but the keydiffernce is that the infected Person still remains conscious and must suffer the extreme pai...<color=red>BL00D F0R TH3 Bl00DG0DS<color=white>",
                CategoryOverride = ModAPI.FindCategory("Science Hazard Minus"),
                NameToOrderByOverride = "A2",
                ThumbnailOverride = ModAPI.LoadSprite("Textures/TEARSVirusSyringe.png"),
                AfterSpawn = (Instance) =>
                {
                    UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());

                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BioSyringe.png");
                    Instance.GetOrAddComponent<TEARSVirusSyringe>();

                    UnityEngine.Object.Destroy(Instance.GetComponent<Collider2D>());
                    Instance.AddComponent<PolygonCollider2D>();
                    Instance.GetComponent<PolygonCollider2D>().pathCount = 15;
                    Instance.GetComponent<PolygonCollider2D>().autoTiling = true;
                }
            });

            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Life Syringe"),
                NameOverride = "Calyxanide Syringe",
                DescriptionOverride = "Calyxanide basically cures Victims, that haven't fully transformed into Husks or Cordyceps Husks.It also kills the Velonaceps Calyx Parasite and Cordyceps Fungus that resides in the Victim itself...However it kills fully transformed Husks and Cordyceps Husks...",
                CategoryOverride = ModAPI.FindCategory("Science Hazard Minus"),
                NameToOrderByOverride = "B0",
                ThumbnailOverride = ModAPI.LoadSprite("Textures/CalyxanideSyringeView.png"),
                AfterSpawn = (Instance) =>
                {
                    UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());

                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BioSyringe.png");
                    Instance.GetOrAddComponent<CalyxanideSyringe>();

                    UnityEngine.Object.Destroy(Instance.GetComponent<Collider2D>());
                    Instance.AddComponent<PolygonCollider2D>();
                    Instance.GetComponent<PolygonCollider2D>().pathCount = 15;
                    Instance.GetComponent<PolygonCollider2D>().autoTiling = true;
                }
            });
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Life Syringe"),
                NameOverride = "Zombie Cure Syringe",
                DescriptionOverride = "The Zombie Cure basically cures Victims, that haven't fully transformed into any type of Zombie...However it kills fully transformed Zombies...(Currently only cures T.E.A.R.S Infected)",
                CategoryOverride = ModAPI.FindCategory("Science Hazard Minus"),
                NameToOrderByOverride = "B1",
                ThumbnailOverride = ModAPI.LoadSprite("Textures/ZombieCureSyringe.png"),
                AfterSpawn = (Instance) =>
                {
                    UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());

                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BioSyringe.png");
                    Instance.GetOrAddComponent<ZombieCureSyringe>();

                    UnityEngine.Object.Destroy(Instance.GetComponent<Collider2D>());
                    Instance.AddComponent<PolygonCollider2D>();
                    Instance.GetComponent<PolygonCollider2D>().pathCount = 15;
                    Instance.GetComponent<PolygonCollider2D>().autoTiling = true;
                }
            });
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Life Syringe"),
                NameOverride = "Viral Uranium Isotope Syringe",
                DescriptionOverride = "Contains A Virus, which biological Structure is based on multiple known and unknown Uranium Isotopes...It's quite contagious and also slowly kills it's Host...",
                CategoryOverride = ModAPI.FindCategory("Science Hazard Minus"),
                NameToOrderByOverride = "A2",
                ThumbnailOverride = ModAPI.LoadSprite("Textures/ViralUraniumIsotopeSyringeView.png"),
                AfterSpawn = (Instance) =>
                {
                    UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BioSyringe.png");
                    Instance.GetOrAddComponent<UraniumIsotopeVirusSyringe>();

                    UnityEngine.Object.Destroy(Instance.GetComponent<Collider2D>());
                    Instance.AddComponent<PolygonCollider2D>();
                    Instance.GetComponent<PolygonCollider2D>().pathCount = 15;
                    Instance.GetComponent<PolygonCollider2D>().autoTiling = true;
                }
            });
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Life Syringe"),
                NameOverride = "Anti Radiation Syringe",
                DescriptionOverride = "The content of this Syringe neutralizes any Radiation in the Target Entity...Only Works when the Victim is Alive btw...",
                CategoryOverride = ModAPI.FindCategory("Science Hazard Minus"),
                NameToOrderByOverride = "B2",
                ThumbnailOverride = ModAPI.LoadSprite("Textures/AntiRadiationSyringeView.png"),
                AfterSpawn = (Instance) =>
                {
                    UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());

                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/BioSyringe.png");
                    Instance.GetOrAddComponent<AntiRadiationSyringe>();

                    UnityEngine.Object.Destroy(Instance.GetComponent<Collider2D>());
                    Instance.AddComponent<PolygonCollider2D>();
                    Instance.GetComponent<PolygonCollider2D>().pathCount = 15;
                    Instance.GetComponent<PolygonCollider2D>().autoTiling = true;
                }
            });

            //Biogrenades

            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Life Syringe"),
                NameOverride = "Velonaceps Calyx Eggs Bio Grenade",
                DescriptionOverride = "The content of this Grenade spreads Velonaceps Calyx Eggs in the Air of the Target Area...",
                CategoryOverride = ModAPI.FindCategory("Science Hazard Minus"),
                NameToOrderByOverride = "C1",
                ThumbnailOverride = ModAPI.LoadSprite("Textures/HuskGrenadeView.png"),
                AfterSpawn = (Instance) =>
                {
                    UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());

                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/HuskParasiteGrenade.png");

                    Instance.GetOrAddComponent<VelonacepsCalyxEggsSyringe>();
                    Instance.GetOrAddComponent<BioGrenadeHandler>();

                    UnityEngine.Object.Destroy(Instance.GetComponent<Collider2D>());
                    Instance.AddComponent<PolygonCollider2D>();
                    Instance.GetComponent<PolygonCollider2D>().pathCount = 15;
                    Instance.GetComponent<PolygonCollider2D>().autoTiling = true;
                }
            });
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Life Syringe"),
                NameOverride = "T.E.A.R.S Bio Grenade",
                DescriptionOverride = "<color=red>...3ND 0CR SCFF3RR!NG...",
                CategoryOverride = ModAPI.FindCategory("Science Hazard Minus"),
                NameToOrderByOverride = "C12",
                ThumbnailOverride = ModAPI.LoadSprite("Textures/TEARSVirusGrenadeView.png"),
                AfterSpawn = (Instance) =>
                {
                    UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());

                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/HuskParasiteGrenade.png");

                    Instance.GetOrAddComponent<TEARSVirusSyringe>();
                    Instance.GetOrAddComponent<BioGrenadeHandler>();

                    UnityEngine.Object.Destroy(Instance.GetComponent<Collider2D>());
                    Instance.AddComponent<PolygonCollider2D>();
                    Instance.GetComponent<PolygonCollider2D>().pathCount = 15;
                    Instance.GetComponent<PolygonCollider2D>().autoTiling = true;
                }
            });
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Life Syringe"),
                NameOverride = "Cordyceps Fungus Spore Bio Grenade",
                DescriptionOverride = "The content of this Grenade spreads Cordyceps Spores in the Air of the Target Area...",
                CategoryOverride = ModAPI.FindCategory("Science Hazard Minus"),
                NameToOrderByOverride = "C2",
                ThumbnailOverride = ModAPI.LoadSprite("Textures/CordycepsHuskGrenadeView.png"),
                AfterSpawn = (Instance) =>
                {
                    UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());

                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/CordycepsHuskGrenade.png");

                    Instance.GetOrAddComponent<CordycepsFungusSporeSyringe>();
                    Instance.GetOrAddComponent<BioGrenadeHandler>();

                    UnityEngine.Object.Destroy(Instance.GetComponent<Collider2D>());
                    Instance.AddComponent<PolygonCollider2D>();
                    Instance.GetComponent<PolygonCollider2D>().pathCount = 15;
                    Instance.GetComponent<PolygonCollider2D>().autoTiling = true;
                }
            });
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Life Syringe"),
                NameOverride = "Viral Uranium Isotope Bio Grenade",
                DescriptionOverride = "The content of this Grenade spreads a Viral Uranium Isotope in the Target Area...",
                CategoryOverride = ModAPI.FindCategory("Science Hazard Minus"),
                NameToOrderByOverride = "C3",
                ThumbnailOverride = ModAPI.LoadSprite("Textures/RadiationGrenadeView.png"),
                AfterSpawn = (Instance) =>
                {
                    UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());

                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/RadiationGrenade.png");

                    Instance.GetOrAddComponent<UraniumIsotopeVirusSyringe>();
                    Instance.GetOrAddComponent<BioGrenadeHandler>();

                    UnityEngine.Object.Destroy(Instance.GetComponent<Collider2D>());
                    Instance.AddComponent<PolygonCollider2D>();
                    Instance.GetComponent<PolygonCollider2D>().pathCount = 15;
                    Instance.GetComponent<PolygonCollider2D>().autoTiling = true;
                }
            });
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Life Syringe"),
                NameOverride = "Calyxanide Bio Grenade",
                DescriptionOverride = "The content of this Grenade neutralizes any Husk Infection in the Target Area...",
                CategoryOverride = ModAPI.FindCategory("Science Hazard Minus"),
                NameToOrderByOverride = "D1",
                ThumbnailOverride = ModAPI.LoadSprite("Textures/CalyxanideGrenadeView.png"),
                AfterSpawn = (Instance) =>
                {
                    UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());

                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/CalyxanideGrenade.png");

                    Instance.GetOrAddComponent<CalyxanideSyringe>();
                    Instance.GetOrAddComponent<BioGrenadeHandler>();

                    UnityEngine.Object.Destroy(Instance.GetComponent<Collider2D>());
                    Instance.AddComponent<PolygonCollider2D>();
                    Instance.GetComponent<PolygonCollider2D>().pathCount = 15;
                    Instance.GetComponent<PolygonCollider2D>().autoTiling = true;
                }
            });
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Life Syringe"),
                NameOverride = "Zombie Cure Bio Grenade",
                DescriptionOverride = "The content of this Grenade neutralizes any type of Zombie Infection in the Target Area...(Currently only cures T.E.A.R.S Infected)",
                CategoryOverride = ModAPI.FindCategory("Science Hazard Minus"),
                NameToOrderByOverride = "D11",
                ThumbnailOverride = ModAPI.LoadSprite("Textures/ZombieCureGrenadeView.png"),
                AfterSpawn = (Instance) =>
                {
                    UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());

                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/ZombieCureGrenade.png");

                    Instance.GetOrAddComponent<ZombieCureSyringe>();
                    Instance.GetOrAddComponent<BioGrenadeHandler>();

                    UnityEngine.Object.Destroy(Instance.GetComponent<Collider2D>());
                    Instance.AddComponent<PolygonCollider2D>();
                    Instance.GetComponent<PolygonCollider2D>().pathCount = 15;
                    Instance.GetComponent<PolygonCollider2D>().autoTiling = true;
                }
            });
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Life Syringe"),
                NameOverride = "Anti Radiation Bio Grenade",
                DescriptionOverride = "The content of this Grenade neutralizes any Radiation in the Target Area...",
                CategoryOverride = ModAPI.FindCategory("Science Hazard Minus"),
                NameToOrderByOverride = "D2",
                ThumbnailOverride = ModAPI.LoadSprite("Textures/AntiRadiationGrenadeView.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/AntiRadiationGrenade.png");

                    UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());
                    Instance.GetOrAddComponent<AntiRadiationSyringe>();
                    Instance.GetOrAddComponent<BioGrenadeHandler>();

                    UnityEngine.Object.Destroy(Instance.GetComponent<Collider2D>());
                    Instance.AddComponent<PolygonCollider2D>();
                    Instance.GetComponent<PolygonCollider2D>().pathCount = 15;
                    Instance.GetComponent<PolygonCollider2D>().autoTiling = true;
                }
            });
            ModAPI.Register(new Modification()
            {
                OriginalItem = ModAPI.FindSpawnable("Empty Syringe"),
                NameOverride = "Empty Bio Grenade",
                DescriptionOverride = "This Grenade can be filled with any Liquid, which then gets released in the target Area...",
                CategoryOverride = ModAPI.FindCategory("Science Hazard Minus"),
                NameToOrderByOverride = "D3",
                ThumbnailOverride = ModAPI.LoadSprite("Textures/EmptyGrenadeView.png"),
                AfterSpawn = (Instance) =>
                {
                    Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("Textures/EmptyGrenade.png");
                    UnityEngine.Object.Destroy(Instance.GetComponent<SyringeBehaviour>());
                    Instance.GetOrAddComponent<EmptySyringe>();
                    Instance.GetOrAddComponent<BioGrenadeHandler>();

                    UnityEngine.Object.Destroy(Instance.GetComponent<Collider2D>());
                    Instance.AddComponent<PolygonCollider2D>();
                    Instance.GetComponent<PolygonCollider2D>().pathCount = 15;
                    Instance.GetComponent<PolygonCollider2D>().autoTiling = true;
                }
            });
        }
    }
    public class EmptySyringe : SyringeBehaviour
    {
        public override string GetLiquidID() => (string)null;
    }
    public class VelonacepsCalyxEggsSyringe : SyringeBehaviour
    {
        public override string GetLiquidID() => VelonacepsCalyxBlood.ID;
    }
    public class CordycepsFungusSporeSyringe : SyringeBehaviour
    {
        public override string GetLiquidID() => CordycepsSpores.ID;
    }
    public class TEARSVirusSyringe : SyringeBehaviour
    {
        public override string GetLiquidID() => TEARSVirus.ID;
    }
    public class CalyxanideSyringe : SyringeBehaviour
    {
        public override string GetLiquidID() => Calyxanide.ID;
    }
    public class ZombieCureSyringe : SyringeBehaviour
    {
        public override string GetLiquidID() => ZombieCure.ID;
    }    
    public class UraniumIsotopeVirusSyringe : SyringeBehaviour
    {
        public override string GetLiquidID() => UraniumIsotopeVirus.ID;
    }
    public class AntiRadiationSyringe : SyringeBehaviour
    {
        public override string GetLiquidID() => AntiRadiation.ID;
    }
    public class VelonacepsCalyxBlood : Blood
    {
        public const string ID = "VelonacepsCalyxBlood";

        public VelonacepsCalyxBlood() => this.Color = new Color(0.272f, 0.175f, 0.05f, 1f);

        public override void OnEnterLimb(LimbBehaviour Limb)
        {
                if (Limb.gameObject.name == "Head")
                {
                    if (Limb.gameObject.GetComponent<HuskCuredDebug>() == false)
                    {
                        Limb.gameObject.GetOrAddComponent<HuskInfectionBehaviour>();
                    }
                    if (Limb.gameObject.GetComponent<HuskCuredDebug>() == true)
                    {
                        foreach (LimbBehaviour x in Limb.Person.Limbs)
                        {
                            if (x.transform.GetComponent<LimbBehaviour>() == true)
                            {
                                x.CirculationBehaviour.ForceSetAllLiquid(0f);
                                double num = (double)x.CirculationBehaviour.AddLiquid(Limb.GetOriginalBloodType(), 0.75f);
                                x.CirculationBehaviour.BloodFlow = 0.75f;
                            }
                        }
                        Limb.gameObject.GetOrAddComponent<HuskInfectionBehaviour>();
                        UnityEngine.Object.Destroy(Limb.GetComponent<HuskCuredDebug>());
                    }
                }
            
        }

        public override void OnExitContainer(BloodContainer container)
        {

        }
    }
    public class HeadcrabBlood : GorseBlood
    {
        public const string ID = "HeadcrabBlood";

        public HeadcrabBlood() => this.Color = new Color(0.818f, 0.617f, 0f, 1f);

        public override void OnEnterLimb(LimbBehaviour Limb)
        {
            
        }

        public override void OnExitContainer(BloodContainer container)
        {

        }
    }
    public class SkulkcrabBlood : GorseBlood
    {
        public const string ID = "SkulkcrabBlood";

        public SkulkcrabBlood() => this.Color = new Color(0f, 0.901f, 0.827f, 1f);

        public override void OnEnterLimb(LimbBehaviour Limb)
        {

        }

        public override void OnExitContainer(BloodContainer container)
        {

        }
    }
    public class CordycepsSpores : Blood
    {
        public const string ID = "CordycepsFungusSpores";

        public CordycepsSpores() => this.Color = new Color(0.272f, 0.275f, 0.00f, 1f);

        public override void OnEnterLimb(LimbBehaviour Limb)
        {
                if (Limb.gameObject.name == "Head")
                {
                    if (Limb.gameObject.GetComponent<HuskCuredDebug>() == false)
                    {
                        Limb.gameObject.GetOrAddComponent<CordycepsInfectionBehaviour>();
                    }
                    if (Limb.gameObject.GetComponent<HuskCuredDebug>() == true)
                    {
                        foreach (LimbBehaviour x in Limb.Person.Limbs)
                        {
                            if (x.transform.GetComponent<LimbBehaviour>() == true)
                            {
                                x.CirculationBehaviour.ForceSetAllLiquid(0f);
                                double num = (double)x.CirculationBehaviour.AddLiquid(Limb.GetOriginalBloodType(), 0.75f);
                                x.CirculationBehaviour.BloodFlow = 0.75f;
                            }
                        }
                        Limb.gameObject.GetOrAddComponent<CordycepsInfectionBehaviour>();
                        UnityEngine.Object.Destroy(Limb.GetComponent<HuskCuredDebug>());
                    }
                }
            
        }

        public override void OnExitContainer(BloodContainer container)
        {

        }
    }
    public class TEARSVirus : Blood
    {
        public const string ID = "T.E.A.R.S Virus";

        public TEARSVirus() => this.Color = new Color(0.45f, 0f, 0.095f, 1f);

        public override void OnEnterLimb(LimbBehaviour Limb)
        {
            if (Limb.gameObject.name == "Head")
            {
                if (Limb.gameObject.GetComponent<ZombieCuredDebug>() == false)
                {
                    Limb.gameObject.GetOrAddComponent<TEARSPlagueInfectionBehaviour>();
                }
                if (Limb.gameObject.GetComponent<ZombieCuredDebug>() == true)
                {
                    foreach (LimbBehaviour x in Limb.Person.Limbs)
                    {
                        if (x.transform.GetComponent<LimbBehaviour>() == true)
                        {
                            x.CirculationBehaviour.ForceSetAllLiquid(0f);
                            double num = (double)x.CirculationBehaviour.AddLiquid(Limb.GetOriginalBloodType(), 0.75f);
                            x.CirculationBehaviour.BloodFlow = 0.75f;
                        }
                    }
                    Limb.gameObject.GetOrAddComponent<TEARSPlagueInfectionBehaviour>();
                    UnityEngine.Object.Destroy(Limb.GetComponent<ZombieCuredDebug>());
                }
            }

        }

        public override void OnExitContainer(BloodContainer container)
        {

        }
    }
    public class ZombieCure : TemporaryBodyLiquid
    {
        public const string ID = "ZombieCure";
        public bool SussyAmogusExplosion = false;
        public ZombieCure() => this.Color = new Color(0.0f, 0.7325f, 0.0f, 1f);

        public override void OnEnterLimb(LimbBehaviour Limb)
        {
            if (Limb.gameObject.name == "Head")
            {
                if (Limb.gameObject.GetComponent<TEARSPlagueInfectionBehaviour>() == true)
                {
                    if (Limb.gameObject.GetComponent<TEARSPlagueInfectionBehaviour>().HasFullyTranformed == false)
                    {
                        if (Limb.gameObject.GetComponent<TEARSPlagueInfectionBehaviour>() == true)
                        {
                            foreach (LimbBehaviour x in Limb.Person.Limbs)
                            {
                                if (x.transform.GetComponent<LimbBehaviour>() == true)
                                {
                                    x.CirculationBehaviour.ForceSetAllLiquid(0f);
                                    double num = (double)x.CirculationBehaviour.AddLiquid(Limb.GetOriginalBloodType(), 0.75f);
                                    x.CirculationBehaviour.BloodFlow = 0.75f;
                                }
                            }
                            Limb.gameObject.AddComponent<ZombieCuredDebug>();
                            UnityEngine.Object.Destroy(Limb.gameObject.GetComponent<TEARSPlagueInfectionBehaviour>());
                        }
                    }
                    if (Limb.gameObject.GetComponent<TEARSPlagueInfectionBehaviour>().HasFullyTranformed == true)
                    {
                        SussyAmogusExplosion = true;
                    }
                }
                if (Limb.gameObject.GetComponent<HuskInfectionBehaviour>() == false && Limb.gameObject.GetComponent<CordycepsInfectionBehaviour>() == false)
                {
                    
                }
            }
            if (SussyAmogusExplosion == true)
            {
                Limb.Crush();
                SussyAmogusExplosion = false;
            }
        }

        public override void OnExitContainer(BloodContainer container)
        {

        }

        public override void OnEnterContainer(BloodContainer container)
        {

        }
    }

    public class Calyxanide : TemporaryBodyLiquid
    {
        public const string ID = "Calyxanide";
        public bool SussyAmogusExplosion = false;
        public Calyxanide() => this.Color = new Color(0.0f, 0.6325f, 0.6325f, 1f);

        public override void OnEnterLimb(LimbBehaviour Limb)
        {
            if (Limb.gameObject.name == "Head" )
            {
                if (Limb.gameObject.GetComponent<HuskInfectionBehaviour>() == true)
                {
                    if (Limb.gameObject.GetComponent<HuskInfectionBehaviour>().HasFullyTranformed == false)
                    {
                        if (Limb.gameObject.GetComponent<HuskInfectionBehaviour>() == true)
                        {
                            foreach (LimbBehaviour x in Limb.Person.Limbs)
                            {
                                if (x.transform.GetComponent<LimbBehaviour>() == true)
                                {
                                    x.CirculationBehaviour.ForceSetAllLiquid(0f);
                                    double num = (double)x.CirculationBehaviour.AddLiquid(Limb.GetOriginalBloodType(), 0.75f);
                                    x.CirculationBehaviour.BloodFlow = 0.75f;
                                }
                            }
                            Limb.gameObject.AddComponent<HuskCuredDebug>();
                            UnityEngine.Object.Destroy(Limb.gameObject.GetComponent<HuskInfectionBehaviour>());
                        }
                    }
                    if (Limb.gameObject.GetComponent<HuskInfectionBehaviour>().HasFullyTranformed == true)
                    {
                        SussyAmogusExplosion = true;                
                    }
                }
                if (Limb.gameObject.GetComponent<CordycepsInfectionBehaviour>() == true)
                {
                    if (Limb.gameObject.GetComponent<CordycepsInfectionBehaviour>().HasFullyTranformed == false)
                    {
                        if (Limb.gameObject.GetComponent<CordycepsInfectionBehaviour>() == true)
                        {
                            foreach (LimbBehaviour x in Limb.Person.Limbs)
                            {
                                if (x.transform.GetComponent<LimbBehaviour>() == true)
                                {
                                    x.CirculationBehaviour.ForceSetAllLiquid(0f);
                                    double num = (double)x.CirculationBehaviour.AddLiquid(Limb.GetOriginalBloodType(), 0.75f);
                                    x.CirculationBehaviour.BloodFlow = 0.75f;
                                }
                            }
                            Limb.gameObject.AddComponent<HuskCuredDebug>();
                            UnityEngine.Object.Destroy(Limb.gameObject.GetComponent<CordycepsInfectionBehaviour>());
                        }
                    }
                    if (Limb.gameObject.GetComponent<CordycepsInfectionBehaviour>().HasFullyTranformed == true)
                    {
                        SussyAmogusExplosion = true;
                    }
                }
            }
            if(SussyAmogusExplosion == true)
            {
                Limb.Crush();
                SussyAmogusExplosion = false;
            }
        }

        public override void OnExitContainer(BloodContainer container)
        {

        }

        public override void OnEnterContainer(BloodContainer container)
        {

        }
    }

    public class UraniumIsotopeVirus : TemporaryBodyLiquid
    {
        public const string ID = "UraniumIsotopeVirus";
        public UraniumIsotopeVirus() => this.Color = new Color(0.75f, 0.75f, 0f, 1f);

        public override void OnEnterLimb(LimbBehaviour Limb)
        {
            foreach (LimbBehaviour x in Limb.Person.Limbs)
            {
                if (x.transform.GetComponent<LimbBehaviour>() == true)
                {
                    if (x.gameObject.name == "Head")
                    {
                        x.transform.gameObject.GetOrAddComponent<ViralRadiationSickness>();
                    }
                    Limb.transform.gameObject.GetOrAddComponent<ViralRadiationSicknessSpreader>();
                }
            }
        }

        public override void OnExitContainer(BloodContainer container)
        {

        }

        public override void OnEnterContainer(BloodContainer container)
        {

        }

        public override void OnUpdate(BloodContainer container)
        {
            if (container is CirculationBehaviour circulationBehaviour)
            {
                switch (circulationBehaviour.Limb.SpeciesIdentity)
                {
                    case "Android":
                        circulationBehaviour.Limb.BaseStrength = Mathf.Lerp(circulationBehaviour.Limb.BaseStrength, 18f, 0.5f);
                        break;
                    default:
                        if ((double)circulationBehaviour.Limb.PhysicalBehaviour.Temperature < 40.0)
                            circulationBehaviour.Limb.PhysicalBehaviour.Temperature += UnityEngine.Random.value;
                        if (circulationBehaviour.Limb.RoughClassification != LimbBehaviour.BodyPart.Head)
                            break;
                        if ((double)UnityEngine.Random.value > 0.995000004768372)
                            circulationBehaviour.Limb.Damage(circulationBehaviour.Limb.Health + 1f);
                        if ((double)UnityEngine.Random.value > 0.9)
                            circulationBehaviour.Limb.Person.AddPain(UnityEngine.Random.value * 60f);
                        circulationBehaviour.Limb.Person.Consciousness *= 0.99f;
                        break;
                }
            }
            else
                Utils.LiquidMixProcess(container, (Liquid)this, Liquid.GetLiquid("AntiRadiation"), Liquid.GetLiquid("MENDING SERUM"), 0.4f);
            Utils.LiquidMixProcess(container, (Liquid)this, Liquid.GetLiquid("AntiRadiation"), Liquid.GetLiquid("TRITIUM"), 0.3f);
        }

    }
    public class AntiRadiation : TemporaryBodyLiquid
    {
        public const string ID = "AntiRadiation";
        public AntiRadiation() => this.Color = new Color(0.25f, 0.5f, 0.35f, 1f);

        public override void OnEnterLimb(LimbBehaviour Limb)
        {
            if (Limb.transform.GetComponent<LimbBehaviour>() == true)
            {
                if (Limb.Health > 0)
                {
                    if (Limb.transform.gameObject.GetComponent<UraniumIsotopeVirusSyringe>() == true)
                    {
                        UnityEngine.Object.Destroy(Limb.transform.gameObject.GetComponent<UraniumIsotopeVirusSyringe>());
                    }
                    if (Limb.transform.gameObject.GetComponent<ViralRadiationSicknessSpreader>() == true)
                    {
                        UnityEngine.Object.Destroy(Limb.transform.gameObject.GetComponent<ViralRadiationSicknessSpreader>());
                    }
                    if (Limb.transform.gameObject.GetComponent<ViralRadiationSickness>() == true)
                    {
                        UnityEngine.Object.Destroy(Limb.transform.gameObject.GetComponent<ViralRadiationSickness>());
                    }
                    if (Limb.transform.gameObject.GetComponent<GlowInTheDarkBehaviour>() == true)
                    {
                        UnityEngine.Object.Destroy(Limb.transform.gameObject.GetComponent<GlowInTheDarkBehaviour>());
                    }
                }
            }
        }

        public override void OnUpdate(BloodContainer container)
        {
            Utils.LiquidMixProcess(container, (Liquid)this, Liquid.GetLiquid("UraniumIsotopeVirus"), Liquid.GetLiquid("IMMORTALITY SERUM"), 0.8f);
        }

        public override void OnExitContainer(BloodContainer container)
        {

        }

        public override void OnEnterContainer(BloodContainer container)
        {

        }
    }
 
 public static class RuntimeComponentCopier
    {
        private const BindingFlags bindingFlags = BindingFlags.Public | BindingFlags.NonPublic | BindingFlags.Instance | BindingFlags.Default | BindingFlags.DeclaredOnly;

        public static T GetCopyOf<T>(this Component comp, T other) where T : Component
        {
            Type type = comp.GetType();
            if (type != other.GetType()) return null; // type mis-match

            List<Type> derivedTypes = new List<Type>();
            Type derived = type.BaseType;
            while (derived != null)
            {
                if (derived == typeof(MonoBehaviour))
                {
                    break;
                }
                derivedTypes.Add(derived);
                derived = derived.BaseType;
            }

            IEnumerable<PropertyInfo> pinfos = type.GetProperties(bindingFlags);

            foreach (Type derivedType in derivedTypes)
            {
                pinfos = pinfos.Concat(derivedType.GetProperties(bindingFlags));
            }

            pinfos = from property in pinfos
                     where !(type == typeof(Rigidbody) && property.Name == "inertiaTensor") // Special case for Rigidbodies inertiaTensor which isn't catched for some reason.
                     where !property.CustomAttributes.Any(attribute => attribute.AttributeType == typeof(ObsoleteAttribute))
                     select property;
            foreach (var pinfo in pinfos)
            {
                if (pinfo.CanWrite)
                {
                    if (pinfos.Any(e => e.Name == $"shared{char.ToUpper(pinfo.Name[0])}{pinfo.Name.Substring(1)}"))
                    {
                        continue;
                    }
                    try
                    {
                        pinfo.SetValue(comp, pinfo.GetValue(other, null), null);
                    }
                    catch { } // In case of NotImplementedException being thrown. For some reason specifying that exception didn't seem to catch it, so I didn't catch anything specific.
                }
            }

            IEnumerable<FieldInfo> finfos = type.GetFields(bindingFlags);

            foreach (var finfo in finfos)
            {

                foreach (Type derivedType in derivedTypes)
                {
                    if (finfos.Any(e => e.Name == $"shared{char.ToUpper(finfo.Name[0])}{finfo.Name.Substring(1)}"))
                    {
                        continue;
                    }
                    finfos = finfos.Concat(derivedType.GetFields(bindingFlags));
                }
            }

            foreach (var finfo in finfos)
            {
                finfo.SetValue(comp, finfo.GetValue(other));
            }

            finfos = from field in finfos
                     where field.CustomAttributes.Any(attribute => attribute.AttributeType == typeof(ObsoleteAttribute))
                     select field;
            foreach (var finfo in finfos)
            {
                finfo.SetValue(comp, finfo.GetValue(other));
            }

            return comp as T;
        }

        public static T AddComponent<T>(this GameObject go, T toAdd) where T : Component
        {
            return go.AddComponent(toAdd.GetType()).GetCopyOf(toAdd) as T;
        }
    }
}