using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using MainModClass;

namespace MainModClass
{
    public class HeadcrabHand : MonoBehaviour
    {
        public bool Skulkcrab;
        public bool FastHeadcrab;
        public bool PoisonHeadcrab;
        public bool HasFullyTranformed = true;
        public bool HasAddedClaws = false;
        public bool CanAttack = true;
        public void Update()
        {

        }
        public void OnCollisionEnter2D(Collision2D Collision)
        {
            if (HasFullyTranformed == true)
            {
                if (Collision.gameObject.GetComponent<LimbBehaviour>() == true)
                {
                    if (PoisonHeadcrab == false && FastHeadcrab == false)
                    {
                        float RandomBiteStrenght = UnityEngine.Random.Range(10f, 27.5f);
                        int InfectionChance = UnityEngine.Random.Range(0, 5);
                        int RandomBiteAudio = UnityEngine.Random.Range(0, 2);
                        if (InfectionChance != 0)
                        {
                            foreach (LimbBehaviour x in Collision.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
                            {
                                if (CanAttack == true)
                                {
                                    Collision.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.ShotDamage(RandomBiteStrenght, (Vector3)Collision.contacts[0].point);
                                    if (RandomBiteAudio == 0)
                                    {
                                        GameObject gameObject1 = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, Collision.transform.position, Quaternion.identity);
                                        gameObject1.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));

                                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness -= 0.075f;
                                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.ShockLevel += 0.075f;
                                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.PainLevel += 0.05f;

                                        Collision.transform.GetComponent<LimbBehaviour>().Health -= RandomBiteStrenght;
                                        transform.gameObject.AddComponent<AudioSource>().PlayOneShot(((IList<AudioClip>)transform.GetComponent<LimbBehaviour>().PhysicalBehaviour.Properties.StabSound).PickRandom<AudioClip>());
                                    }
                                    if (RandomBiteAudio == 1)
                                    {
                                        GameObject gameObject1 = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, Collision.transform.position, Quaternion.identity);
                                        gameObject1.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));

                                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness -= 0.075f;
                                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.ShockLevel += 0.075f;
                                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.PainLevel += 0.05f;

                                        Collision.transform.GetComponent<LimbBehaviour>().Health -= RandomBiteStrenght;
                                        transform.GetComponent<LimbBehaviour>().PhysicalBehaviour.PlayClipOnce(((IList<AudioClip>)transform.GetComponent<LimbBehaviour>().Person.DismembermentClips).PickRandom<AudioClip>());
                                    }
                                    StartCoroutine(Hand());
                                }
                            }
                        }
                    }
                    if (FastHeadcrab == true)
                    {
                        float RandomBiteStrenght = UnityEngine.Random.Range(15f, 35f);
                        int InfectionChance = UnityEngine.Random.Range(0, 5);
                        int RandomBiteAudio = UnityEngine.Random.Range(0, 2);
                        if (InfectionChance != 0)
                        {
                            foreach (LimbBehaviour x in Collision.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
                            {
                                if (CanAttack == true)
                                {
                                    Collision.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.ShotDamage(RandomBiteStrenght, (Vector3)Collision.contacts[0].point);
                                    if (RandomBiteAudio == 0)
                                    {
                                        GameObject gameObject1 = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, Collision.transform.position, Quaternion.identity);
                                        gameObject1.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));

                                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness -= 0.025f;
                                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.ShockLevel += 0.125f;
                                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.PainLevel += 0.125f;
                                        Collision.transform.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.AcidProgress += 0.225f;
                                        Collision.transform.GetComponent<LimbBehaviour>().Health -= RandomBiteStrenght;
                                        transform.gameObject.AddComponent<AudioSource>().PlayOneShot(((IList<AudioClip>)transform.GetComponent<LimbBehaviour>().PhysicalBehaviour.Properties.StabSound).PickRandom<AudioClip>());
                                    }
                                    if (RandomBiteAudio == 1)
                                    {
                                        GameObject gameObject1 = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, Collision.transform.position, Quaternion.identity);
                                        gameObject1.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));

                                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness -= 0.01f;
                                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.ShockLevel += 0.05f;
                                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.PainLevel += 0.025f;
                                        Collision.transform.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.AcidProgress += 0.375f;

                                        Collision.transform.GetComponent<LimbBehaviour>().Health -= RandomBiteStrenght;
                                        transform.GetComponent<LimbBehaviour>().PhysicalBehaviour.PlayClipOnce(((IList<AudioClip>)transform.GetComponent<LimbBehaviour>().Person.DismembermentClips).PickRandom<AudioClip>());
                                    }
                                    StartCoroutine(Hand());
                                }
                            }
                        }
                    }
                    if (Skulkcrab == true)
                    {
                        float RandomBiteStrenght = UnityEngine.Random.Range(15f, 35f);
                        int InfectionChance = UnityEngine.Random.Range(0, 5);
                        int RandomBiteAudio = UnityEngine.Random.Range(0, 2);
                        if (InfectionChance != 0)
                        {
                            foreach (LimbBehaviour x in Collision.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
                            {
                                if (CanAttack == true)
                                {
                                    Collision.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.ShotDamage(RandomBiteStrenght, (Vector3)Collision.contacts[0].point);
                                    if (RandomBiteAudio == 0)
                                    {
                                        GameObject gameObject1 = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, Collision.transform.position, Quaternion.identity);
                                        gameObject1.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));

                                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness -= 0.25f;
                                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.ShockLevel += 0.5f;
                                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.PainLevel += 0.25f;
                                        Collision.transform.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.AcidProgress += 0.25f;
                                        Collision.transform.GetComponent<LimbBehaviour>().Health -= RandomBiteStrenght * 2;
                                        transform.gameObject.AddComponent<AudioSource>().PlayOneShot(((IList<AudioClip>)transform.GetComponent<LimbBehaviour>().PhysicalBehaviour.Properties.StabSound).PickRandom<AudioClip>());
                                    }
                                    if (RandomBiteAudio == 1)
                                    {
                                        GameObject gameObject1 = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, Collision.transform.position, Quaternion.identity);
                                        gameObject1.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));

                                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness -= 0.25f;
                                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.ShockLevel += 0.5f;
                                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.PainLevel += 0.25f;
                                        Collision.transform.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.AcidProgress += 0.45f;

                                        Collision.transform.GetComponent<LimbBehaviour>().Health -= RandomBiteStrenght * 2;
                                        transform.GetComponent<LimbBehaviour>().PhysicalBehaviour.PlayClipOnce(((IList<AudioClip>)transform.GetComponent<LimbBehaviour>().Person.DismembermentClips).PickRandom<AudioClip>());
                                    }
                                    StartCoroutine(Hand());
                                }
                            }
                        }
                    }
                    if (PoisonHeadcrab == true)
                    {
                        float RandomBiteStrenght = UnityEngine.Random.Range(12.5f, 25f);
                        int InfectionChance = UnityEngine.Random.Range(0, 5);
                        int RandomBiteAudio = UnityEngine.Random.Range(0, 2);
                        if (InfectionChance != 0)
                        {
                            foreach (LimbBehaviour x in Collision.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
                            {
                                if (CanAttack == true)
                                {
                                    Collision.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.ShotDamage(RandomBiteStrenght, (Vector3)Collision.contacts[0].point);
                                    if (RandomBiteAudio == 0)
                                    {
                                        GameObject gameObject1 = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, Collision.transform.position, Quaternion.identity);
                                        gameObject1.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));

                                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness -= 0.1f;
                                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.ShockLevel += 0.025f;
                                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.PainLevel += 0.05f;
                                        Collision.transform.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.AcidProgress += 0.20f;

                                        Collision.transform.GetComponent<LimbBehaviour>().Health -= RandomBiteStrenght;
                                        transform.gameObject.AddComponent<AudioSource>().PlayOneShot(((IList<AudioClip>)transform.GetComponent<LimbBehaviour>().PhysicalBehaviour.Properties.StabSound).PickRandom<AudioClip>());
                                    }
                                    if (RandomBiteAudio == 1)
                                    {
                                        GameObject gameObject1 = UnityEngine.Object.Instantiate<GameObject>(x.transform.gameObject.GetComponent<LimbBehaviour>().Person.BloodExplosionPrefab, Collision.transform.position, Quaternion.identity);
                                        gameObject1.GetComponentInChildren<BloodExplosionBehaviour>().SetColor(x.transform.gameObject.GetComponent<LimbBehaviour>().CirculationBehaviour.GetComputedColor(x.transform.gameObject.GetComponent<LimbBehaviour>().GetOriginalBloodType().Color));

                                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.Consciousness -= 0.1f;
                                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.ShockLevel += 0.025f;
                                        x.transform.gameObject.GetComponent<LimbBehaviour>().Person.PainLevel += 0.05f;
                                        Collision.transform.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.AcidProgress += 0.025f;

                                        Collision.transform.GetComponent<LimbBehaviour>().Health -= RandomBiteStrenght;
                                        transform.GetComponent<LimbBehaviour>().PhysicalBehaviour.PlayClipOnce(((IList<AudioClip>)transform.GetComponent<LimbBehaviour>().Person.DismembermentClips).PickRandom<AudioClip>());
                                    }
                                    StartCoroutine(Hand());
                                }
                            }
                        }
                    }
                }
            }
        }
        public IEnumerator Hand()
        {
            CanAttack = false;
            yield return new WaitForSeconds(0.25f);
            CanAttack = true;
        }
    }
}