using System;
using System.Collections;
using System.Collections.Generic;
using System.IO;
using UnityEngine;
using UnityEngine.Events;
using MainModClass;

namespace MainModClass
{
    public class ViralRadiationSickness : MonoBehaviour
    {
        public bool HasStarted = false;
        public bool HasStarted10 = false;
        //public GameObject BleedingEyes;
        public void Update()
        {
            if (HasStarted == false)
            {
                /*
                Transform Head = this.transform;
                GameObject Eyes = new GameObject("Eyes");
                Eyes.transform.SetParent(Head);
                Eyes.transform.localPosition = new Vector3(0.014425f, 0.0725f);
                Eyes.transform.rotation = this.transform.rotation;
                Eyes.transform.localScale = new Vector3(1f, 1f);
                SpriteRenderer spriteRenderer = Eyes.AddComponent<SpriteRenderer>();
                spriteRenderer.sprite = MainModClass.RadiationBleedingEyes1;
                spriteRenderer.sortingLayerName = "Foreground";
                BleedingEyes = Eyes.transform.gameObject;
                if (BleedingEyes != null)
                {
                    Debug.Log("BleedingEyes.name");
                }
                */
                foreach (LimbBehaviour x in transform.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
                {
                    if (x.transform.GetComponent<LimbBehaviour>() == true)
                    {
                        x.transform.gameObject.GetOrAddComponent<GlowInTheDarkBehaviour>();
                    }
                }
                StartCoroutine(SymptomTicks());
                HasStarted = true;
            }
            if (HasStarted == true)
            {
                if(HasStarted10 == false)
                foreach (LimbBehaviour x in transform.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
                {
                    if (x.transform.GetComponent<LimbBehaviour>() == true)
                    {
                        if(transform.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.AcidProgress == 1 || transform.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.AcidProgress > 1)
                        {
                                StartCoroutine(LastSymptomTicks());
                                HasStarted10 = true;
                        }
                    }
                }
            }
        }

        public IEnumerator SymptomTicks()
        {
            float RandomTime = UnityEngine.Random.Range(0.75f, 1.25f);
            yield return new WaitForSeconds(RandomTime);

            foreach (LimbBehaviour x in transform.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
            {
                if (x.transform.GetComponent<LimbBehaviour>() == true)
                {
                    float RandomRadiationAddition = UnityEngine.Random.Range(0.01f, 0.03f);
                    x.transform.gameObject.GetComponent<LimbBehaviour>().SkinMaterialHandler.AcidProgress += RandomRadiationAddition;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.PainLevel += RandomRadiationAddition;
                    x.transform.gameObject.GetComponent<LimbBehaviour>().Person.ShockLevel += RandomRadiationAddition;
                }
            }
            StartCoroutine(SymptomTicks());
        }
        public IEnumerator LastSymptomTicks()
        {
            float RandomTime = UnityEngine.Random.Range(0.25f, 7.5f);
            yield return new WaitForSeconds(RandomTime);

            foreach (LimbBehaviour x in transform.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
            {
                if (x.transform.GetComponent<LimbBehaviour>() == true)
                {
                    x.transform.gameObject.GetOrAddComponent<UraniumIsotopeVirusSyringe>();

                    if (x.transform.gameObject.GetComponent<UraniumIsotopeVirusSyringe>() == true)
                    {
                        SyringeExplosionBehaviour component = UnityEngine.Object.Instantiate<GameObject>(Resources.Load<GameObject>("Prefabs/SyringeExplosion"), x.transform.position, Quaternion.identity).GetComponent<SyringeExplosionBehaviour>();
                        component.Colour = x.transform.GetComponent<UraniumIsotopeVirusSyringe>().GetComputedColor();
                        component.Liquids = (IEnumerable<Liquid>)x.transform.GetComponent<UraniumIsotopeVirusSyringe>().LiquidDistribution.Keys;
                        component.Amount = x.transform.GetComponent<UraniumIsotopeVirusSyringe>().TotalLiquidAmount / (float)x.transform.GetComponent<UraniumIsotopeVirusSyringe>().LiquidDistribution.Count;
                    }
                }
            }
            StartCoroutine(Decay());
        }
        public IEnumerator Decay()
        {
            float RandomTime = UnityEngine.Random.Range(10f, 12.5f);
            yield return new WaitForSeconds(RandomTime);

            foreach (LimbBehaviour x in transform.gameObject.GetComponent<LimbBehaviour>().Person.Limbs)
            {
                if (x.transform.GetComponent<LimbBehaviour>() == true)
                {
                    x.Crush();
                }
            }
        }
    }
}